diff --git a/deps/v8/src/codegen/ppc/constants-ppc.h b/deps/v8/src/codegen/ppc/constants-ppc.h
index f6ebc6a7..52e92091 100644
--- a/deps/v8/src/codegen/ppc/constants-ppc.h
+++ b/deps/v8/src/codegen/ppc/constants-ppc.h
@@ -20,7 +20,7 @@
 #define UNIMPLEMENTED_PPC()
 #endif
 
-#if V8_HOST_ARCH_PPC &&                                            \
+#if (V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) &&                    \
     (V8_OS_AIX || (V8_TARGET_ARCH_PPC64 && V8_TARGET_BIG_ENDIAN && \
                    (!defined(_CALL_ELF) || _CALL_ELF == 1)))
 #define ABI_USES_FUNCTION_DESCRIPTORS 1
@@ -28,28 +28,30 @@
 #define ABI_USES_FUNCTION_DESCRIPTORS 0
 #endif
 
-#if !V8_HOST_ARCH_PPC || V8_OS_AIX || V8_TARGET_ARCH_PPC64
+#if !(V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) || V8_OS_AIX || \
+    V8_TARGET_ARCH_PPC64 || V8_OS_MACOSX
 #define ABI_PASSES_HANDLES_IN_REGS 1
 #else
 #define ABI_PASSES_HANDLES_IN_REGS 0
 #endif
 
-#if !V8_HOST_ARCH_PPC || !V8_TARGET_ARCH_PPC64 || V8_TARGET_LITTLE_ENDIAN || \
-    (defined(_CALL_ELF) && _CALL_ELF == 2)
+#if !(V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) || !V8_TARGET_ARCH_PPC64 || \
+    V8_TARGET_LITTLE_ENDIAN || (defined(_CALL_ELF) && _CALL_ELF == 2)
 #define ABI_RETURNS_OBJECT_PAIRS_IN_REGS 1
 #else
 #define ABI_RETURNS_OBJECT_PAIRS_IN_REGS 0
 #endif
 
-#if !V8_HOST_ARCH_PPC ||     \
-    (V8_TARGET_ARCH_PPC64 && \
+#if !(V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) || \
+    (V8_TARGET_ARCH_PPC64 &&                     \
      (V8_TARGET_LITTLE_ENDIAN || (defined(_CALL_ELF) && _CALL_ELF == 2)))
 #define ABI_CALL_VIA_IP 1
 #else
 #define ABI_CALL_VIA_IP 0
 #endif
 
-#if !V8_HOST_ARCH_PPC || V8_OS_AIX || V8_TARGET_ARCH_PPC64
+#if !(V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) || V8_OS_AIX || \
+    V8_TARGET_ARCH_PPC64
 #define ABI_TOC_REGISTER 2
 #else
 #define ABI_TOC_REGISTER 13
@@ -1130,7 +1132,7 @@ using Instr = uint32_t;
   V(and_, ANDX, 0x7C000038)              \
   /* AND with Complement */              \
   V(andc, ANDCX, 0x7C000078)             \
-  /* OR */                               \
+  /* OR with Complement */               \
   V(orx, ORX, 0x7C000378)                \
   /* OR with Complement */               \
   V(orc, ORC, 0x7C000338)                \
@@ -1170,7 +1172,7 @@ using Instr = uint32_t;
   V(lhbrx, LHBRX, 0x7C00062C)                           \
   /* Load Word Byte-Reverse Indexed */                  \
   V(lwbrx, LWBRX, 0x7C00042C)                           \
-  /* Load Doubleword Byte-Reverse Indexed */            \
+  /* Load Byte and Zero Indexed */                      \
   V(ldbrx, LDBRX, 0x7C000428)                           \
   /* Load Byte and Zero Indexed */                      \
   V(lbzx, LBZX, 0x7C0000AE)                             \
@@ -1234,7 +1236,7 @@ using Instr = uint32_t;
   V(cmpl, CMPL, 0x7C000040)
 
 #define PPC_X_OPCODE_EH_S_FORM_LIST(V)                    \
-  /* Store Byte Conditional Indexed */                    \
+  /* Store Word Conditional Indexed & record CR0 */       \
   V(stbcx, STBCX, 0x7C00056D)                             \
   /* Store Halfword Conditional Indexed Xform */          \
   V(sthcx, STHCX, 0x7C0005AD)                             \
@@ -1254,7 +1256,7 @@ using Instr = uint32_t;
   V(ldarx, LDARX, 0x7C0000A8)
 
 #define PPC_X_OPCODE_UNUSED_LIST(V)                                           \
-  /* Bit Permute Doubleword */                                                \
+  /* Move To Condition Register from FPSCR */                                 \
   V(bpermd, BPERMD, 0x7C0001F8)                                               \
   /* Extend Sign Word */                                                      \
   V(extsw, EXTSW, 0x7C0007B4)                                                 \
@@ -1286,7 +1288,7 @@ using Instr = uint32_t;
   V(eqv, EQV, 0x7C000238)                                                     \
   /* Instruction Cache Block Invalidate */                                    \
   V(icbi, ICBI, 0x7C0007AC)                                                   \
-  /* NAND */                                                                  \
+  /* Synchronize */                                                           \
   V(nand, NAND, 0x7C0003B8)                                                   \
   /* Parity Word */                                                           \
   V(prtyw, PRTYW, 0x7C000134)                                                 \
@@ -1512,7 +1514,7 @@ using Instr = uint32_t;
   V(stfdpx, STFDPX, 0x7C00072E)                                               \
   /* Floating Absolute Value */                                               \
   V(fabs, FABS, 0xFC000210)                                                   \
-  /* Floating Convert From Integer Doubleword */                              \
+  /* Floating Convert To Integer Word */                                      \
   V(fcfid, FCFID, 0xFC00069C)                                                 \
   /* Floating Convert From Integer Doubleword Single */                       \
   V(fcfids, FCFIDS, 0xEC00069C)                                               \
@@ -1533,7 +1535,7 @@ using Instr = uint32_t;
   V(fctidz, FCTIDZ, 0xFC00065E)                                               \
   /* Floating Convert To Integer Word */                                      \
   V(fctiw, FCTIW, 0xFC00001C)                                                 \
-  /* Floating Convert To Integer Word Unsigned */                             \
+  /* Floating Convert To Integer Word with round to Zero */                   \
   V(fctiwu, FCTIWU, 0xFC00011C)                                               \
   /* Floating Convert To Integer Word Unsigned with round toward Zero */      \
   V(fctiwuz, FCTIWUZ, 0xFC00011E)                                             \
@@ -1541,13 +1543,13 @@ using Instr = uint32_t;
   V(fctiwz, FCTIWZ, 0xFC00001E)                                               \
   /* Floating Move Register */                                                \
   V(fmr, FMR, 0xFC000090)                                                     \
-  /* Floating Negative Absolute Value */                                      \
+  /* Floating Negate */                                                       \
   V(fnabs, FNABS, 0xFC000110)                                                 \
   /* Floating Negate */                                                       \
   V(fneg, FNEG, 0xFC000050)                                                   \
   /* Floating Round to Single-Precision */                                    \
   V(frsp, FRSP, 0xFC000018)                                                   \
-  /* Move From FPSCR */                                                       \
+  /* Move To FPSCR Bit 0 */                                                   \
   V(mffs, MFFS, 0xFC00048E)                                                   \
   /* Move To FPSCR Bit 0 */                                                   \
   V(mtfsb0, MTFSB0, 0xFC00008C)                                               \
@@ -1743,17 +1745,17 @@ using Instr = uint32_t;
 #define PPC_DQ_OPCODE_LIST(V) V(lsq, LSQ, 0xE0000000)
 
 #define PPC_D_OPCODE_LIST(V)                    \
-  /* Trap Doubleword Immediate */               \
+  /* Add Immediate */                           \
   V(tdi, TDI, 0x08000000)                       \
   /* Add Immediate */                           \
   V(addi, ADDI, 0x38000000)                     \
   /* Add Immediate Carrying */                  \
   V(addic, ADDIC, 0x30000000)                   \
-  /* Add Immediate Carrying & record CR0 */     \
+  /* Add Immediate Shifted */                   \
   V(addicx, ADDICx, 0x34000000)                 \
   /* Add Immediate Shifted */                   \
   V(addis, ADDIS, 0x3C000000)                   \
-  /* AND Immediate & record CR0 */              \
+  /* Compare Immediate */                       \
   V(andix, ANDIx, 0x70000000)                   \
   /* AND Immediate Shifted & record CR0 */      \
   V(andisx, ANDISx, 0x74000000)                 \
@@ -1837,17 +1839,17 @@ using Instr = uint32_t;
   V(mfspr, MFSPR, 0x7C0002A6)                   \
   /* Move To Condition Register Fields */       \
   V(mtcrf, MTCRF, 0x7C000120)                   \
-  /* Move To One Condition Register Field */    \
+  /* Move To Special Purpose Register */        \
   V(mtocrf, MTOCRF, 0x7C100120)                 \
   /* Move To Special Purpose Register */        \
   V(mtspr, MTSPR, 0x7C0003A6)                   \
-  /* Debugger Notify Halt */                    \
+  /* Move From Device Control Register */       \
   V(dnh, DNH, 0x4C00018C)                       \
   /* Move From Device Control Register */       \
   V(mfdcr, MFDCR, 0x7C000286)                   \
   /* Move To Device Control Register */         \
   V(mtdcr, MTDCR, 0x7C000386)                   \
-  /* Move from Performance Monitor Register */  \
+  /* Move From Branch History Rolling Buffer */ \
   V(mfpmr, MFPMR, 0x7C00029C)                   \
   /* Move To Performance Monitor Register */    \
   V(mtpmr, MTPMR, 0x7C00039C)                   \
@@ -1899,7 +1901,7 @@ using Instr = uint32_t;
   V(frsqrte, FRSQRTE, 0xFC000034)                       \
   /* Floating Select */                                 \
   V(fsel, FSEL, 0xFC00002E)                             \
-  /* Floating Square Root */                            \
+  /* Floating Subtract */                               \
   V(fsqrt, FSQRT, 0xFC00002C)                           \
   /* Floating Square Root Single */                     \
   V(fsqrts, FSQRTS, 0xEC00002C)                         \
@@ -1987,7 +1989,7 @@ using Instr = uint32_t;
   V(bc, BCX, 0x40000000)
 
 #define PPC_XO_OPCODE_LIST(V)                                               \
-  /* Divide Doubleword */                                                   \
+  /* Add */                                                                 \
   V(divd, DIVD, 0x7C0003D2)                                                 \
   /* Divide Doubleword Extended */                                          \
   V(divde, DIVDE, 0x7C000352)                                               \
@@ -2033,7 +2035,7 @@ using Instr = uint32_t;
   V(addzeo, ADDZEO, 0x7C000594)                                             \
   /* Divide Word Format */                                                  \
   V(divw, DIVW, 0x7C0003D6)                                                 \
-  /* Divide Word Extended */                                                \
+  /* Divide Word & record OV */                                             \
   V(divwe, DIVWE, 0x7C000356)                                               \
   /* Divide Word Extended & record OV */                                    \
   V(divweo, DIVWEO, 0x7C000756)                                             \
@@ -2079,7 +2081,7 @@ using Instr = uint32_t;
   V(subfze, SUBFZE, 0x7C000190)                                             \
   /* Subtract From Zero Extended & record OV */                             \
   V(subfzeo, SUBFZEO, 0x7C000590)                                           \
-  /* Add and Generate Sixes */                                              \
+  /* Multiply Accumulate Cross Halfword to Word Modulo Signed */            \
   V(addg, ADDG, 0x7C000094)                                                 \
   /* Multiply Accumulate Cross Halfword to Word Modulo Signed */            \
   V(macchw, MACCHW, 0x10000158)                                             \
@@ -2983,6 +2985,11 @@ class DoubleRegisters {
  private:
   static const char* names_[kNumDoubleRegisters];
 };
+
+static constexpr int kR0DwarfCode = 0;
+static constexpr int kFpDwarfCode = 31;  // frame-pointer
+static constexpr int kLrDwarfCode = 65;  // return-address(lr)
+static constexpr int kSpDwarfCode = 1;   // stack-pointer (sp)
 }  // namespace internal
 }  // namespace v8
 
diff --git a/deps/v8/src/codegen/ppc/cpu-ppc.cc b/deps/v8/src/codegen/ppc/cpu-ppc.cc
index 243fa29a..9559af77 100644
--- a/deps/v8/src/codegen/ppc/cpu-ppc.cc
+++ b/deps/v8/src/codegen/ppc/cpu-ppc.cc
@@ -4,7 +4,7 @@
 
 // CPU specific code for ppc independent of OS goes here.
 
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 
 #include "src/codegen/cpu-features.h"
 
@@ -47,4 +47,4 @@ void CpuFeatures::FlushICache(void* buffer, size_t size) {
 }  // namespace v8
 
 #undef INSTR_AND_DATA_CACHE_COHERENCY
-#endif  // V8_TARGET_ARCH_PPC
+#endif  // V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
diff --git a/deps/v8/src/codegen/ppc/interface-descriptors-ppc.cc b/deps/v8/src/codegen/ppc/interface-descriptors-ppc.cc
index 3d378d7a..f2264b05 100644
--- a/deps/v8/src/codegen/ppc/interface-descriptors-ppc.cc
+++ b/deps/v8/src/codegen/ppc/interface-descriptors-ppc.cc
@@ -2,7 +2,7 @@
 // Use of this source code is governed by a BSD-style license that can be
 // found in the LICENSE file.
 
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 
 #include "src/codegen/interface-descriptors.h"
 
@@ -286,4 +286,4 @@ void RunMicrotasksEntryDescriptor::InitializePlatformSpecific(
 }  // namespace internal
 }  // namespace v8
 
-#endif  // V8_TARGET_ARCH_PPC
+#endif  // V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
diff --git a/deps/v8/src/codegen/ppc/macro-assembler-ppc.cc b/deps/v8/src/codegen/ppc/macro-assembler-ppc.cc
index 41162063..65a9f040 100644
--- a/deps/v8/src/codegen/ppc/macro-assembler-ppc.cc
+++ b/deps/v8/src/codegen/ppc/macro-assembler-ppc.cc
@@ -5,7 +5,7 @@
 #include <assert.h>  // For assert
 #include <limits.h>  // For LONG_MIN, LONG_MAX.
 
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 
 #include "src/base/bits.h"
 #include "src/base/division-by-constant.h"
@@ -24,6 +24,16 @@
 #include "src/snapshot/snapshot.h"
 #include "src/wasm/wasm-code-manager.h"
 
+#include <iostream>
+
+#if __FLOAT_WORD_ORDER == __LITTLE_ENDIAN
+#define LO_WORD_OFFSET 0
+#define HI_WORD_OFFSET 4
+#else
+#define LO_WORD_OFFSET 4
+#define HI_WORD_OFFSET 0
+#endif
+
 // Satisfy cpplint check, but don't include platform-specific header. It is
 // included recursively via macro-assembler.h.
 #if 0
@@ -687,26 +697,106 @@ void TurboAssembler::CanonicalizeNaN(const DoubleRegister dst,
   fsub(dst, src, kDoubleRegZero);
 }
 
+void TurboAssembler::ConvertIntToFloatingPointNoPPC64(Register src,
+    DoubleRegister double_dst,
+    bool result_is_a_float,
+    bool src_is_unsigned) {
+
+    Register scratch = r11;
+    DoubleRegister double_scratch = kScratchDoubleReg;
+
+  subi(sp, sp, Operand(8));  // reserve one temporary double on the stack
+
+  // sign-extend src to 64-bit and store it to temp double on the stack
+#if V8_TARGET_ARCH_PPC64
+  extsw(r0, src);
+  std(r0, MemOperand(sp, 0));
+#else
+  srawi(r0, src, 31);
+#if __FLOAT_WORD_ORDER == __LITTLE_ENDIAN
+  stw(r0, MemOperand(sp, 4));
+  stw(src, MemOperand(sp, 0));
+#else
+  stw(r0, MemOperand(sp, 0));
+  stw(src, MemOperand(sp, 4));
+#endif
+#endif
+  if (src_is_unsigned) {
+    // load 0x4330000000000000 into double_scratch
+    lis(scratch, Operand(0x4330));
+    stw(scratch, MemOperand(sp, HI_WORD_OFFSET));
+    lis(scratch, Operand::Zero());
+    stw(scratch, MemOperand(sp, LO_WORD_OFFSET));
+    lfd(double_scratch, MemOperand(sp, 0));
+
+    // load 0x1.00000dddddddd x10^D into double_dst
+    lis(scratch, Operand(0x4330));
+    stw(scratch, MemOperand(sp, HI_WORD_OFFSET));
+    stw(src, MemOperand(sp, LO_WORD_OFFSET));
+  } else {
+    // load 0x4330000080000000 into double_scratch
+    lis(scratch, Operand(0x4330));
+    stw(scratch, MemOperand(sp, HI_WORD_OFFSET));
+    lis(scratch, Operand(-0x8000));
+    stw(scratch, MemOperand(sp, LO_WORD_OFFSET));
+    lfd(double_scratch, MemOperand(sp, 0));
+
+  // load into FPR
+    // load 0x1.00000dddddddd x10^D into double_dst
+    lis(scratch, Operand(0x4330));
+    stw(scratch, MemOperand(sp, HI_WORD_OFFSET));
+    xoris(scratch, src, Operand(0x8000));
+    stw(scratch, MemOperand(sp, LO_WORD_OFFSET));
+  }
+
+  // Convert to double word FP from stack
+  lfd(double_dst, MemOperand(sp, 0));
+  fsub(double_dst, double_dst, double_scratch);
+
+  addi(sp, sp, Operand(8));  // restore stack
+
+  if (result_is_a_float) {
+    // Round to single word FP
+    frsp(double_dst, double_dst);
+  }
+}
+
 void TurboAssembler::ConvertIntToDouble(Register src, DoubleRegister dst) {
+#ifdef V8_TARGET_ARCH_PPC64
   MovIntToDouble(dst, src, r0);
   fcfid(dst, dst);
+#else
+  ConvertIntToFloatingPointNoPPC64(src, dst, false, false);
+#endif
 }
 
 void TurboAssembler::ConvertUnsignedIntToDouble(Register src,
                                                 DoubleRegister dst) {
+#ifdef V8_TARGET_ARCH_PPC64
   MovUnsignedIntToDouble(dst, src, r0);
   fcfid(dst, dst);
+#else
+  ConvertIntToFloatingPointNoPPC64(src, dst, false, true);
+#endif
 }
 
 void TurboAssembler::ConvertIntToFloat(Register src, DoubleRegister dst) {
-  MovIntToDouble(dst, src, r0);
-  fcfids(dst, dst);
+#ifdef V8_TARGET_ARCH_PPC64
+  MovUnsignedIntToDouble(dst, src, r0);
+  fcfid(dst, dst);
+#else
+  ConvertIntToFloatingPointNoPPC64(src, dst, true, false);
+#endif
 }
 
 void TurboAssembler::ConvertUnsignedIntToFloat(Register src,
                                                DoubleRegister dst) {
+#ifdef V8_TARGET_ARCH_PPC64
   MovUnsignedIntToDouble(dst, src, r0);
   fcfids(dst, dst);
+#else
+  ConvertIntToFloatingPointNoPPC64(src, dst, true, true);
+#endif
 }
 
 #if V8_TARGET_ARCH_PPC64
@@ -742,6 +832,7 @@ void TurboAssembler::ConvertDoubleToInt64(const DoubleRegister double_input,
                                           const Register dst,
                                           const DoubleRegister double_dst,
                                           FPRoundingMode rounding_mode) {
+#if V8_TARGET_ARCH_PPC64
   if (rounding_mode == kRoundToZero) {
     fctidz(double_dst, double_input);
   } else {
@@ -749,6 +840,7 @@ void TurboAssembler::ConvertDoubleToInt64(const DoubleRegister double_input,
     fctid(double_dst, double_input);
     ResetRoundingMode();
   }
+#endif
 
   MovDoubleToInt64(
 #if !V8_TARGET_ARCH_PPC64
@@ -2433,7 +2525,7 @@ void MacroAssembler::AddSmiLiteral(Register dst, Register src, Smi smi,
   LoadSmiLiteral(scratch, smi);
   add(dst, src, scratch);
 #else
-  Add(dst, src, reinterpret_cast<intptr_t>(smi), scratch);
+  Add(dst, src, reinterpret_cast<uintptr_t>(smi.ptr()), scratch);
 #endif
 }
 
@@ -2443,7 +2535,7 @@ void MacroAssembler::SubSmiLiteral(Register dst, Register src, Smi smi,
   LoadSmiLiteral(scratch, smi);
   sub(dst, src, scratch);
 #else
-  Add(dst, src, -(reinterpret_cast<intptr_t>(smi)), scratch);
+  Add(dst, src, -(reinterpret_cast<uintptr_t>(smi.ptr())), scratch);
 #endif
 }
 
@@ -2476,9 +2568,17 @@ void TurboAssembler::LoadP(Register dst, const MemOperand& mem,
       // Todo: enhance to use scratch if dst is unsuitable
       DCHECK_NE(dst, r0);
       addi(dst, mem.ra(), Operand(adj));
+#if V8_TARGET_ARCH_PPC64
       ld(dst, MemOperand(dst, alignedOffset));
+#else
+      lwz(dst, MemOperand(dst, alignedOffset));
+#endif
     } else {
+#if V8_TARGET_ARCH_PPC64
       ld(dst, mem);
+#else
+      lwz(dst, mem);
+#endif
     }
   }
 }
@@ -2940,15 +3040,26 @@ void TurboAssembler::JumpIfLessThan(Register x, int32_t y, Label* dest) {
 }
 
 void TurboAssembler::LoadEntryFromBuiltinIndex(Register builtin_index) {
-  STATIC_ASSERT(kSystemPointerSize == 8);
-  STATIC_ASSERT(kSmiShiftSize == 31);
+#if V8_TARGET_ARCH_PPC64
+   STATIC_ASSERT(kSystemPointerSize == 8);
+   STATIC_ASSERT(kSmiShiftSize == 31);
+#else
+  STATIC_ASSERT(kSystemPointerSize == 4);
+  STATIC_ASSERT(kSmiShiftSize == 0);
+#endif
   STATIC_ASSERT(kSmiTagSize == 1);
   STATIC_ASSERT(kSmiTag == 0);
 
+
   // The builtin_index register contains the builtin index as a Smi.
   // Untagging is folded into the indexing operand below.
+#ifdef V8_TARGET_ARCH_PPC64
   ShiftRightArithImm(builtin_index, builtin_index,
                      kSmiShift - kSystemPointerSizeLog2);
+#else
+  ShiftLeftImm(builtin_index, builtin_index,
+                     Operand(kSystemPointerSizeLog2 - kSmiTagSize));
+#endif
   addi(builtin_index, builtin_index,
        Operand(IsolateData::builtin_entry_table_offset()));
   LoadPX(builtin_index, MemOperand(kRootRegister, builtin_index));
@@ -3063,18 +3174,30 @@ void TurboAssembler::CallForDeoptimization(Address target, int deopt_id) {
 }
 
 void TurboAssembler::ZeroExtByte(Register dst, Register src) {
+#if V8_TARGET_ARCH_PPC64
   clrldi(dst, src, Operand(56));
+#else
+  clrlwi(dst, src, Operand(24));
+#endif
 }
 
 void TurboAssembler::ZeroExtHalfWord(Register dst, Register src) {
+#if V8_TARGET_ARCH_PPC64
   clrldi(dst, src, Operand(48));
+#else
+  clrlwi(dst, src, Operand(16));
+#endif
 }
 
 void TurboAssembler::ZeroExtWord32(Register dst, Register src) {
+#if V8_TARGET_ARCH_PPC64
   clrldi(dst, src, Operand(32));
+#else
+  clrlwi(dst, src, Operand(32));
+#endif
 }
 
 }  // namespace internal
 }  // namespace v8
 
-#endif  // V8_TARGET_ARCH_PPC
+#endif  // V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
diff --git a/deps/v8/src/codegen/ppc/macro-assembler-ppc.h b/deps/v8/src/codegen/ppc/macro-assembler-ppc.h
index fd4cb601..d7b68793 100644
--- a/deps/v8/src/codegen/ppc/macro-assembler-ppc.h
+++ b/deps/v8/src/codegen/ppc/macro-assembler-ppc.h
@@ -69,6 +69,13 @@ class V8_EXPORT_PRIVATE TurboAssembler : public TurboAssemblerBase {
  public:
   using TurboAssemblerBase::TurboAssemblerBase;
 
+  #if V8_TARGET_ARCH_PPC
+  void ConvertIntToFloatingPointNoPPC64(Register src,
+    DoubleRegister double_dst,
+    bool result_is_a_float,
+    bool src_is_unsigned);
+  #endif
+
   // Converts the integer (untagged smi) in |src| to a double, storing
   // the result to |dst|
   void ConvertIntToDouble(Register src, DoubleRegister dst);
diff --git a/deps/v8/src/codegen/ppc/register-ppc.h b/deps/v8/src/codegen/ppc/register-ppc.h
index 63a9fd80..61cd3850 100644
--- a/deps/v8/src/codegen/ppc/register-ppc.h
+++ b/deps/v8/src/codegen/ppc/register-ppc.h
@@ -145,7 +145,11 @@ const int kNumSafepointRegisters = 32;
 // The following constants describe the stack frame linkage area as
 // defined by the ABI.  Note that kNumRequiredStackFrameSlots must
 // satisfy alignment requirements (rounding up if required).
-#if V8_TARGET_ARCH_PPC64 &&     \
+#if V8_TARGET_ARCH_PPC
+const int kNumRequiredStackFrameSlots = 4;
+const int kStackFrameLRSlot = 1;
+const int kStackFrameExtraParamSlot = 2;
+#elif V8_TARGET_ARCH_PPC64 &&   \
     (V8_TARGET_LITTLE_ENDIAN || \
      (defined(_CALL_ELF) && _CALL_ELF == 2))  // ELFv2 ABI
 // [0] back chain
diff --git a/deps/v8/src/codegen/register-arch.h b/deps/v8/src/codegen/register-arch.h
index aa668a91..21a72330 100644
--- a/deps/v8/src/codegen/register-arch.h
+++ b/deps/v8/src/codegen/register-arch.h
@@ -16,7 +16,7 @@
 #include "src/codegen/arm64/register-arm64.h"
 #elif V8_TARGET_ARCH_ARM
 #include "src/codegen/arm/register-arm.h"
-#elif V8_TARGET_ARCH_PPC
+#elif V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #include "src/codegen/ppc/register-ppc.h"
 #elif V8_TARGET_ARCH_MIPS
 #include "src/codegen/mips/register-mips.h"
diff --git a/deps/v8/src/codegen/register-configuration.cc b/deps/v8/src/codegen/register-configuration.cc
index c8f768e6..5752b463 100644
--- a/deps/v8/src/codegen/register-configuration.cc
+++ b/deps/v8/src/codegen/register-configuration.cc
@@ -60,6 +60,8 @@ static int get_num_allocatable_double_registers() {
       kMaxAllocatableDoubleRegisterCount;
 #elif V8_TARGET_ARCH_PPC
       kMaxAllocatableDoubleRegisterCount;
+#elif V8_TARGET_ARCH_PPC64
+      kMaxAllocatableDoubleRegisterCount;
 #elif V8_TARGET_ARCH_S390
       kMaxAllocatableDoubleRegisterCount;
 #else
diff --git a/deps/v8/src/codegen/reloc-info.cc b/deps/v8/src/codegen/reloc-info.cc
index a889a8b9..63a6ab99 100644
--- a/deps/v8/src/codegen/reloc-info.cc
+++ b/deps/v8/src/codegen/reloc-info.cc
@@ -329,7 +329,7 @@ bool RelocInfo::OffHeapTargetIsCodedSpecially() {
   return false;
 #elif defined(V8_TARGET_ARCH_IA32) || defined(V8_TARGET_ARCH_MIPS) || \
     defined(V8_TARGET_ARCH_MIPS64) || defined(V8_TARGET_ARCH_PPC) ||  \
-    defined(V8_TARGET_ARCH_S390)
+    defined(V8_TARGET_ARCH_PPC64) || defined(V8_TARGET_ARCH_S390)
   return true;
 #endif
 }
diff --git a/deps/v8/src/common/globals.h b/deps/v8/src/common/globals.h
index a0584b95..4722cbd7 100644
--- a/deps/v8/src/common/globals.h
+++ b/deps/v8/src/common/globals.h
@@ -42,6 +42,9 @@ namespace internal {
 #if (V8_TARGET_ARCH_PPC && !V8_HOST_ARCH_PPC)
 #define USE_SIMULATOR 1
 #endif
+#if (V8_TARGET_ARCH_PPC64 && !V8_HOST_ARCH_PPC64)
+#define USE_SIMULATOR 1
+#endif
 #if (V8_TARGET_ARCH_MIPS && !V8_HOST_ARCH_MIPS)
 #define USE_SIMULATOR 1
 #endif
@@ -55,7 +58,7 @@ namespace internal {
 
 // Determine whether the architecture uses an embedded constant pool
 // (contiguous constant pool embedded in code object).
-#if V8_TARGET_ARCH_PPC
+#if V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64
 #define V8_EMBEDDED_CONSTANT_POOL true
 #else
 #define V8_EMBEDDED_CONSTANT_POOL false
@@ -179,7 +182,8 @@ constexpr int kSystemPointerSizeLog2 = 3;
 constexpr intptr_t kIntptrSignBit =
     static_cast<intptr_t>(uintptr_t{0x8000000000000000});
 constexpr bool kRequiresCodeRange = true;
-#if V8_HOST_ARCH_PPC && V8_TARGET_ARCH_PPC && V8_OS_LINUX
+#if (V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) && \
+    (V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64) && V8_OS_LINUX
 constexpr size_t kMaximalCodeRangeSize = 512 * MB;
 constexpr size_t kMinExpectedOSPageSize = 64 * KB;  // OS page on PPC Linux
 #elif V8_TARGET_ARCH_ARM64
@@ -199,7 +203,8 @@ constexpr size_t kReservedCodeRangePages = 0;
 #else
 constexpr int kSystemPointerSizeLog2 = 2;
 constexpr intptr_t kIntptrSignBit = 0x80000000;
-#if V8_HOST_ARCH_PPC && V8_TARGET_ARCH_PPC && V8_OS_LINUX
+#if (V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) && \
+    (V8_TARGET_ARCH_PPC || V8_TARGET_ARCH_PPC64) && V8_OS_LINUX
 constexpr bool kRequiresCodeRange = false;
 constexpr size_t kMaximalCodeRangeSize = 0 * MB;
 constexpr size_t kMinimumCodeRangeSize = 0 * MB;
@@ -332,7 +337,7 @@ F FUNCTION_CAST(Address addr) {
 // Determine whether the architecture uses function descriptors
 // which provide a level of indirection between the function pointer
 // and the function entrypoint.
-#if V8_HOST_ARCH_PPC &&                                            \
+#if (V8_HOST_ARCH_PPC || V8_HOST_ARCH_PPC64) &&                    \
     (V8_OS_AIX || (V8_TARGET_ARCH_PPC64 && V8_TARGET_BIG_ENDIAN && \
                    (!defined(_CALL_ELF) || _CALL_ELF == 1)))
 #define USES_FUNCTION_DESCRIPTORS 1
diff --git a/deps/v8/src/compiler/backend/instruction-codes.h b/deps/v8/src/compiler/backend/instruction-codes.h
index 589c1bda..e9be4e12 100644
--- a/deps/v8/src/compiler/backend/instruction-codes.h
+++ b/deps/v8/src/compiler/backend/instruction-codes.h
@@ -21,6 +21,8 @@
 #include "src/compiler/backend/x64/instruction-codes-x64.h"
 #elif V8_TARGET_ARCH_PPC
 #include "src/compiler/backend/ppc/instruction-codes-ppc.h"
+#elif V8_TARGET_ARCH_PPC64
+#include "src/compiler/backend/ppc64/instruction-codes-ppc64.h"
 #elif V8_TARGET_ARCH_S390
 #include "src/compiler/backend/s390/instruction-codes-s390.h"
 #else
diff --git a/deps/v8/src/compiler/backend/instruction-selector.cc b/deps/v8/src/compiler/backend/instruction-selector.cc
index 43193ec2..bec33aa9 100644
--- a/deps/v8/src/compiler/backend/instruction-selector.cc
+++ b/deps/v8/src/compiler/backend/instruction-selector.cc
@@ -2539,7 +2539,8 @@ void InstructionSelector::VisitWord32PairShr(Node* node) { UNIMPLEMENTED(); }
 void InstructionSelector::VisitWord32PairSar(Node* node) { UNIMPLEMENTED(); }
 #endif  // V8_TARGET_ARCH_64_BIT
 
-#if !V8_TARGET_ARCH_IA32 && !V8_TARGET_ARCH_ARM && !V8_TARGET_ARCH_MIPS
+#if !V8_TARGET_ARCH_IA32 && !V8_TARGET_ARCH_ARM && !V8_TARGET_ARCH_MIPS && \
+    !V8_TARGET_ARCH_PPC
 void InstructionSelector::VisitWord32AtomicPairLoad(Node* node) {
   UNIMPLEMENTED();
 }
@@ -2576,9 +2577,10 @@ void InstructionSelector::VisitWord32AtomicPairCompareExchange(Node* node) {
   UNIMPLEMENTED();
 }
 #endif  // !V8_TARGET_ARCH_IA32 && !V8_TARGET_ARCH_ARM && !V8_TARGET_ARCH_MIPS
+        // && !V8_TARGET_ARCH_PPC
 
 #if !V8_TARGET_ARCH_X64 && !V8_TARGET_ARCH_ARM64 && !V8_TARGET_ARCH_MIPS64 && \
-    !V8_TARGET_ARCH_S390 && !V8_TARGET_ARCH_PPC
+    !V8_TARGET_ARCH_S390 && !V8_TARGET_ARCH_PPC64
 void InstructionSelector::VisitWord64AtomicLoad(Node* node) { UNIMPLEMENTED(); }
 
 void InstructionSelector::VisitWord64AtomicStore(Node* node) {
@@ -2602,8 +2604,9 @@ void InstructionSelector::VisitWord64AtomicExchange(Node* node) {
 void InstructionSelector::VisitWord64AtomicCompareExchange(Node* node) {
   UNIMPLEMENTED();
 }
-#endif  // !V8_TARGET_ARCH_X64 && !V8_TARGET_ARCH_ARM64 && !V8_TARGET_ARCH_PPC
-        // !V8_TARGET_ARCH_MIPS64 && !V8_TARGET_ARCH_S390
+#endif  // !V8_TARGET_ARCH_X64 && !V8_TARGET_ARCH_ARM64 &&
+        // !V8_TARGET_ARCH_MIPS64 && !V8_TARGET_ARCH_S390 &&
+        // !V8_TARGET_ARCH_PPC64
 
 #if !V8_TARGET_ARCH_X64
 #if !V8_TARGET_ARCH_ARM64
